Loading...
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# This scripts adds local version information from the version
5# control systems git, mercurial (hg) and subversion (svn).
6#
7# If something goes wrong, send a mail the kernel build mailinglist
8# (see MAINTAINERS) and CC Nico Schottelius
9# <nico-linuxsetlocalversion -at- schottelius.org>.
10#
11#
12
13usage() {
14 echo "Usage: $0 [--save-scmversion] [srctree]" >&2
15 exit 1
16}
17
18scm_only=false
19srctree=.
20if test "$1" = "--save-scmversion"; then
21 scm_only=true
22 shift
23fi
24if test $# -gt 0; then
25 srctree=$1
26 shift
27fi
28if test $# -gt 0 -o ! -d "$srctree"; then
29 usage
30fi
31
32scm_version()
33{
34 local short
35 short=false
36
37 cd "$srctree"
38 if test -e .scmversion; then
39 cat .scmversion
40 return
41 fi
42 if test "$1" = "--short"; then
43 short=true
44 fi
45
46 # Check for git and a git repo.
47 if test -z "$(git rev-parse --show-cdup 2>/dev/null)" &&
48 head=$(git rev-parse --verify HEAD 2>/dev/null); then
49
50 # If we are at a tagged commit (like "v2.6.30-rc6"), we ignore
51 # it, because this version is defined in the top level Makefile.
52 if [ -z "$(git describe --exact-match 2>/dev/null)" ]; then
53
54 # If only the short version is requested, don't bother
55 # running further git commands
56 if $short; then
57 echo "+"
58 return
59 fi
60 # If we are past a tagged commit (like
61 # "v2.6.30-rc5-302-g72357d5"), we pretty print it.
62 if atag="$(git describe 2>/dev/null)"; then
63 echo "$atag" | awk -F- '{printf("-%05d", $(NF-1))}'
64 fi
65
66 # Add -g and exactly 12 hex chars.
67 printf '%s%s' -g "$(echo $head | cut -c1-12)"
68 fi
69
70 # Check for uncommitted changes.
71 # This script must avoid any write attempt to the source tree,
72 # which might be read-only.
73 # You cannot use 'git describe --dirty' because it tries to
74 # create .git/index.lock .
75 # First, with git-status, but --no-optional-locks is only
76 # supported in git >= 2.14, so fall back to git-diff-index if
77 # it fails. Note that git-diff-index does not refresh the
78 # index, so it may give misleading results. See
79 # git-update-index(1), git-diff-index(1), and git-status(1).
80 if {
81 git --no-optional-locks status -uno --porcelain 2>/dev/null ||
82 git diff-index --name-only HEAD
83 } | read dummy; then
84 printf '%s' -dirty
85 fi
86 fi
87}
88
89collect_files()
90{
91 local file res=
92
93 for file; do
94 case "$file" in
95 *\~*)
96 continue
97 ;;
98 esac
99 if test -e "$file"; then
100 res="$res$(cat "$file")"
101 fi
102 done
103 echo "$res"
104}
105
106if $scm_only; then
107 if test ! -e .scmversion; then
108 res=$(scm_version)
109 echo "$res" >.scmversion
110 fi
111 exit
112fi
113
114if ! test -e include/config/auto.conf; then
115 echo "Error: kernelrelease not valid - run 'make prepare' to update it" >&2
116 exit 1
117fi
118
119# localversion* files in the build and source directory
120res="$(collect_files localversion*)"
121if test ! "$srctree" -ef .; then
122 res="$res$(collect_files "$srctree"/localversion*)"
123fi
124
125# CONFIG_LOCALVERSION and LOCALVERSION (if set)
126config_localversion=$(sed -n 's/^CONFIG_LOCALVERSION=\(.*\)$/\1/p' include/config/auto.conf)
127res="${res}${config_localversion}${LOCALVERSION}"
128
129# scm version string if not at a tagged commit
130if grep -q "^CONFIG_LOCALVERSION_AUTO=y$" include/config/auto.conf; then
131 # full scm version string
132 res="$res$(scm_version)"
133elif [ "${LOCALVERSION+set}" != "set" ]; then
134 # If the variable LOCALVERSION is not set, append a plus
135 # sign if the repository is not in a clean annotated or
136 # signed tagged state (as git describe only looks at signed
137 # or annotated tags - git tag -a/-s).
138 #
139 # If the variable LOCALVERSION is set (including being set
140 # to an empty string), we don't want to append a plus sign.
141 scm=$(scm_version --short)
142 res="$res${scm:++}"
143fi
144
145echo "$res"
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# This scripts adds local version information from the version
5# control system git.
6#
7# If something goes wrong, send a mail the kernel build mailinglist
8# (see MAINTAINERS) and CC Nico Schottelius
9# <nico-linuxsetlocalversion -at- schottelius.org>.
10#
11#
12
13set -e
14
15usage() {
16 echo "Usage: $0 [--no-local] [srctree]" >&2
17 exit 1
18}
19
20no_local=false
21if test "$1" = "--no-local"; then
22 no_local=true
23 shift
24fi
25
26srctree=.
27if test $# -gt 0; then
28 srctree=$1
29 shift
30fi
31if test $# -gt 0 -o ! -d "$srctree"; then
32 usage
33fi
34
35try_tag() {
36 tag="$1"
37
38 # Is $tag an annotated tag?
39 if [ "$(git cat-file -t "$tag" 2> /dev/null)" != tag ]; then
40 return
41 fi
42
43 # Is it an ancestor of HEAD, and if so, how many commits are in $tag..HEAD?
44 # shellcheck disable=SC2046 # word splitting is the point here
45 set -- $(git rev-list --count --left-right "$tag"...HEAD 2> /dev/null)
46
47 # $1 is 0 if and only if $tag is an ancestor of HEAD. Use
48 # string comparison, because $1 is empty if the 'git rev-list'
49 # command somehow failed.
50 if [ "$1" != 0 ]; then
51 return
52 fi
53
54 # $2 is the number of commits in the range $tag..HEAD, possibly 0.
55 count="$2"
56}
57
58scm_version()
59{
60 local short=false
61 local no_dirty=false
62 local tag
63
64 while [ $# -gt 0 ];
65 do
66 case "$1" in
67 --short)
68 short=true;;
69 --no-dirty)
70 no_dirty=true;;
71 esac
72 shift
73 done
74
75 cd "$srctree"
76
77 if test -n "$(git rev-parse --show-cdup 2>/dev/null)"; then
78 return
79 fi
80
81 if ! head=$(git rev-parse --verify HEAD 2>/dev/null); then
82 return
83 fi
84
85 # mainline kernel: 6.2.0-rc5 -> v6.2-rc5
86 # stable kernel: 6.1.7 -> v6.1.7
87 version_tag=v$(echo "${KERNELVERSION}" | sed -E 's/^([0-9]+\.[0-9]+)\.0(.*)$/\1\2/')
88
89 # try_tag initializes count if the tag is usable.
90 count=
91
92 # If a localversion* file exists, and the corresponding
93 # annotated tag exists and is an ancestor of HEAD, use
94 # it. This is the case in linux-next.
95 if [ -n "${file_localversion#-}" ] ; then
96 try_tag "${file_localversion#-}"
97 fi
98
99 # Otherwise, if a localversion* file exists, and the tag
100 # obtained by appending it to the tag derived from
101 # KERNELVERSION exists and is an ancestor of HEAD, use
102 # it. This is e.g. the case in linux-rt.
103 if [ -z "${count}" ] && [ -n "${file_localversion}" ]; then
104 try_tag "${version_tag}${file_localversion}"
105 fi
106
107 # Otherwise, default to the annotated tag derived from KERNELVERSION.
108 if [ -z "${count}" ]; then
109 try_tag "${version_tag}"
110 fi
111
112 # If we are at the tagged commit, we ignore it because the
113 # version is well-defined. If none of the attempted tags exist
114 # or were usable, $count is still empty.
115 if [ -z "${count}" ] || [ "${count}" -gt 0 ]; then
116
117 # If only the short version is requested, don't bother
118 # running further git commands
119 if $short; then
120 echo "+"
121 return
122 fi
123
124 # If we are past the tagged commit, we pretty print it.
125 # (like 6.1.0-14595-g292a089d78d3)
126 if [ -n "${count}" ]; then
127 printf "%s%05d" "-" "${count}"
128 fi
129
130 # Add -g and exactly 12 hex chars.
131 printf '%s%.12s' -g "$head"
132 fi
133
134 if ${no_dirty}; then
135 return
136 fi
137
138 # Check for uncommitted changes.
139 # This script must avoid any write attempt to the source tree, which
140 # might be read-only.
141 # You cannot use 'git describe --dirty' because it tries to create
142 # .git/index.lock .
143 # First, with git-status, but --no-optional-locks is only supported in
144 # git >= 2.14, so fall back to git-diff-index if it fails. Note that
145 # git-diff-index does not refresh the index, so it may give misleading
146 # results.
147 # See git-update-index(1), git-diff-index(1), and git-status(1).
148 if {
149 git --no-optional-locks status -uno --porcelain 2>/dev/null ||
150 git diff-index --name-only HEAD
151 } | read dummy; then
152 printf '%s' -dirty
153 fi
154}
155
156collect_files()
157{
158 local file res=
159
160 for file; do
161 case "$file" in
162 *\~*)
163 continue
164 ;;
165 esac
166 if test -e "$file"; then
167 res="$res$(cat "$file")"
168 fi
169 done
170 echo "$res"
171}
172
173if [ -z "${KERNELVERSION}" ]; then
174 echo "KERNELVERSION is not set" >&2
175 exit 1
176fi
177
178# localversion* files in the build and source directory
179file_localversion="$(collect_files localversion*)"
180if test ! "$srctree" -ef .; then
181 file_localversion="${file_localversion}$(collect_files "$srctree"/localversion*)"
182fi
183
184if ${no_local}; then
185 echo "${KERNELVERSION}$(scm_version --no-dirty)"
186 exit 0
187fi
188
189if ! test -e include/config/auto.conf; then
190 echo "Error: kernelrelease not valid - run 'make prepare' to update it" >&2
191 exit 1
192fi
193
194# version string from CONFIG_LOCALVERSION
195config_localversion=$(sed -n 's/^CONFIG_LOCALVERSION=\(.*\)$/\1/p' include/config/auto.conf)
196
197# scm version string if not at the kernel version tag or at the file_localversion
198if grep -q "^CONFIG_LOCALVERSION_AUTO=y$" include/config/auto.conf; then
199 # full scm version string
200 scm_version="$(scm_version)"
201elif [ "${LOCALVERSION+set}" != "set" ]; then
202 # If the variable LOCALVERSION is not set, append a plus
203 # sign if the repository is not in a clean annotated or
204 # signed tagged state (as git describe only looks at signed
205 # or annotated tags - git tag -a/-s).
206 #
207 # If the variable LOCALVERSION is set (including being set
208 # to an empty string), we don't want to append a plus sign.
209 scm_version="$(scm_version --short)"
210fi
211
212echo "${KERNELVERSION}${file_localversion}${config_localversion}${LOCALVERSION}${scm_version}"